#ifndef _DHPLAY_H
#define _DHPLAY_H

#if (defined(WIN32) || defined(WIN64))
	#ifdef dhplay_EXPORTS
		#define PLAYSDK_API __declspec(dllexport)
	#else
		#define PLAYSDK_API __declspec(dllimport)
	#endif
	#define CALLMETHOD __stdcall
	#define CALLBACK   __stdcall
#else
	#define CALLMETHOD
	#define CALLBACK
	#define PLAYSDK_API //extern "C"
#endif

#if defined(WIN32) || defined(WIN64)
#include <windows.h>
#else
#ifdef __OBJC__
#include "objc/objc.h"
#else
#define BOOL        int
#endif
#define BYTE		unsigned char
#define PBYTE		BYTE*
#define LPBYTE		BYTE*
#ifndef LONG
#define LONG		int
#endif
#ifndef DWORD
#define DWORD		unsigned int
#endif
#define WORD		unsigned short
#define COLORREF	DWORD
#define HDC			void*
#define HWND		void*
#define LPSTR		char*
#define UINT		unsigned int
#define TRUE		1
#define FALSE		0
#define ULONGLONG	unsigned long long
#define LONGLONG	long long

typedef struct _SYSTEMTIME
{
    WORD wYear;
    WORD wMonth;
    WORD wDayOfWeek;
    WORD wDay;
    WORD wHour;
    WORD wMinute;
    WORD wSecond;
    WORD wMilliseconds;
} SYSTEMTIME, *PSYSTEMTIME, *LPSYSTEMTIME;
#endif

#ifdef	__cplusplus
extern "C" {
#endif

/***********************************************************************************************/
/* 																					   */
/***********************************************************************************************/

/* ͨ */
#define  FUNC_MAX_PORT					511		// ͨţͨŷΧ[0,512)

/* Ƶֵ */
#define MIN_WAVE_COEF					-100	// PLAY_AdjustWaveAudioʹ
#define MAX_WAVE_COEF					100		// PLAY_AdjustWaveAudioʹ

/* ʾ */
#define MAX_DISPLAY_WND					16      // õŵֵ

/* Ż */
#define BUF_VIDEO_SRC					1		// ƵԴ
#define BUF_AUDIO_SRC					2		// ƵԴ
#define BUF_VIDEO_RENDER				3		// Ƶݻ
#define BUF_AUDIO_RENDER				4		// Ƶݻ

/* ļתʽ */
#define BY_FRAMENUM						1		// ֡ŷʽ(PLAY_GetKeyFramePosʹ)
#define BY_FRAMETIME					2		// ʱ䷽ʽ(PLAY_GetKeyFramePosʹ)

/*  */
#define SOURCE_BUF_MAX					1024*100000	// 󳤶
#define SOURCE_BUF_MIN					1024*1024	// С

#define STREAME_REALTIME				0		// ʵʱģʽ
#define STREAME_FILE					1		// ļģʽ

/* Ƶλ */
#define T_AUDIO16						101		// 16λƵ
#define T_AUDIO8						100		// 8λƵ

/* Ƶʽ */
#define T_UYVY							1		// UYVY͵YUVݣڲ֧
#define T_IYUV							3		// IYUV(I420)YUV
#define T_RGB32							7		// RGB32ͣڲ֧

/* aviת */
#define AVI_MEDIACHANGE_FRAMERATE		1		// ֡ʸı
#define AVI_MEDIACHANGE_RESOLUTION		2		// ֱʸı

/* ˮӡ */
#define WATERMARK_DATA_TEXT				0		// 
#define WATERMARK_DATA_JPEG_BMP			1		// JPEGBMPͼƬ
#define WATERMARK_DATA_FRAMEDATA		3		// ֡

/*  */
#define  DH_PLAY_NOERROR							0	//޴
#define  DH_PLAY_COMMON_ERROR						1	//ͨ
#define	 DH_PLAY_PARA_INVALID						2	//Ч
#define  DH_PLAY_ORDER_ERROR						3	//˳򲻶
#define	 DH_PLAY_PORT_OPEN							4	//ͨѾ
#define	 DH_PLAY_PORT_CLOSE							5	//ͨѾر
#define	 DH_PLAY_PORT_INVALID						6	//ͨЧ
#define	 DH_PLAY_PORT_EXIST							7	//ͨѾ
#define  DH_PLAY_OPEN_FILE_ERROR					8	//ļʧ
#define  DH_PLAY_INTERFACE_NOT_SUPPORT				9	//ӿڲ֧
#define  DH_PLAY_HWND_INVALID						10	//ھЧ
#define  DH_PLAY_PLAY_ERROR							11	//ʧ
#define  DH_PLAY_SPEED_INVALID						12	//ٶЧ
#define  DH_PLAY_NOT_FILE							13	//ļģʽ
#define  DH_PLAY_NOT_STREAM							14	//ģʽ
#define  DH_PLAY_NO_FRAME							15	//ǰû֡
#define  DH_PLAY_INDEX_NOT_COMPLETE					16	//ûн
#define  DH_PLAY_INDEX_COMPLETE						17	//ѽļ
#define  DH_PLAY_GET_FILE_SIZE_ERROR				18	//ȡļСʧ
#define  DH_PLAY_CREATE_THREAD_FAIL					19	//߳ʧ
#define  DH_PLAY_CREATE_EVENT_FAIL					20	//ʧ
#define  DH_PLAY_SOUND_SHARE_MODE					21	//ڹģʽ
#define  DH_PLAY_INCLUDE_SOUND_SHARE_PORT			22	//ö˿Ѱ
#define  DH_PLAY_NOT_INCLUDE_SOUND_SHARE_PORT		23	//ö˿δ
#define  DH_PLAY_CREATE_DIR_ERROR					24	//·ʧ
#define  DH_PLAY_CREATE_FILE_ERROR					25	//ļʧ

#define  DH_PLAY_CONVERT_YUV_ERROR					26	//תyuvʧ
#define  DH_PLAY_CONVERT_JPG_ERROR					27	//תjpgʧ
#define  DH_PLAY_CONVERT_BMP_ERROR					28	//תbmpʧ
#define  DH_PLAY_CONVERT_TIFF_ERROR					29	//תtiffʧ
#define  DH_PLAY_HW_CATCH_ERROR					    30	//Ӳץʧ
#define  DH_PLAY_CREATE_VIDEO_RENDER_ERROR			31	//ƵȾʧ
#define  DH_PLAY_NOT_SUPPORT_REF_VALUE				32	//֧ⲿ
#define  DH_PLAY_FORMAT_NOT_SUPPORT					33	//ʽ֧
#define  DH_PLAY_CREATE_RECORD_ERROR				34	//¼ʧ
#define  DH_PLAY_OPEN_RECORD_ERROR					35	//¼ʧ
#define  DH_PLAY_FRAMERATE_ERROR					36	//֡ʴ
#define  DH_PLAY_CREATE_AUDIO_RECORD_ERROR			37	//Ƶ¼ʧ
#define  DH_PLAY_OPEN_AUDIO_RECORD_ERROR			38	//Ƶ¼ʧ
#define	 DH_PLAY_AES_ALLOC_ERROR					39	//aes_allocʧ

#define  DH_PLAY_BUF_OVER				            40  //
#define  DH_PLAY_ALLOC_MEMORY_ERROR		            41  //ڴʧ


/***********************************************************************************************/
/* öٶ																					   */
/***********************************************************************************************/
																								
/* Ⱦģʽ */
typedef enum
{
	RENDER_NOTSET = 0,				// δ
	RENDER_GDI,						// GDIȾ
	RENDER_X11 = RENDER_GDI,		// windowsƽ̨X11Ⱦ
	RENDER_D3D,						// d3dȾ
	RENDER_OPENGL = RENDER_D3D,		// windowsƽ̨openglȾ
	RENDER_DDRAW,					// ddrawȾ
	RENDER_WGL						// windowsƽ̨openglȾ
}RenderType;

/* ģʽ */
typedef enum
{
	DECODE_NOTSET = 0,		// δ
	DECODE_SW,				// 
	DECODE_HW,				// Ӳ뿽ģʽ
	DECODE_HW_FAST,			// Ӳֱʾģʽ
	DECODE_MSDK				// Ӳ룬intel media sdkѷ
}DecodeType;

/* ͼƬʽ */
typedef enum __tPicFormats
{
	PicFormat_BMP = 0,				        // BMP32
	PicFormat_JPEG,							// JPEG
	PicFormat_JPEG_70,						// 70%JPEG
	PicFormat_JPEG_50,						// 50%JPEG
	PicFormat_JPEG_30,						// 30%JPEG
	PicFormat_JPEG_10,						// 10%JPEG
	PicFormat_BMP24,                        // BMP24
	PicFormat_TIFF							// TIFF
} tPicFormats;

/* ȡýϢʽ */
typedef enum _CMD_TYPE
{
	PLAY_CMD_GetTime = 1,			// ʱϢΪ
	PLAY_CMD_GetFileRate = 2,		// ֡Ϣ
	PLAY_CMD_GetMediaInfo = 3,		// ýϢ
	PLAY_CMD_GetRenderNum = 4,		// ǰҪȾ֡
	PLAY_CMD_GetRenderTime = 5,		// ǰҪȾʱ
	PLAY_CMD_GetSrcTime	= 6,		// ʱϢΪ197071պ
	PLAY_CMD_GetCurRenderNum = 7    // ǰ֡ţPLAY_CMD_GetRenderNumһ֡֡
} CMD_TYPE_E;

/* Ƶͬ */
typedef enum
{
	AV_SYNC_VIDEO_MASTER,		  // ƵΪ׼Ƶͬʽ
	AV_SYNC_AUDIO_TIME_STAMP      // ƵʱΪ׼
}AV_SYNC_TYPE;

/***********************************************************************************************/
/* ṹ嶨																				   */
/***********************************************************************************************/

/* ֲʾ */
typedef struct _tagRECT
{
	LONG left;								
	LONG top;								
	LONG right;								
	LONG bottom;							
}DISPLAYRECT;

/* ʱṹ */
#ifndef _DHTIME_
#define _DHTIME_
typedef struct _DHTIME								
{
	DWORD second	:6;						//		0-59		
	DWORD minute	:6;						//		0-59		
	DWORD hour		:5;						//	ʱ	0-23		
	DWORD day		:5;						//		1-31		
	DWORD month		:4;						//		1-12		
	DWORD year		:6;						//		2000-2063	
} DHTIME,*pDHTIME;
#endif

/* ļϢṹʹ */
typedef struct _FILE_INFO
{
	UINT		channel;				// ͨ
	BYTE		alarm;					// 
	BYTE		lock_flag;				// (0δ 1ֶ 2Զ)
	BYTE		video_audio;			// ƵƵ
	BYTE		image;					// ͼ(bit4~6 bit7 ʾʱ)
	BYTE		hint;					// ļʱʹõİʾ
	DHTIME		start_time;				// ʼʱ
	DHTIME		end_time;				// ʱ
	UINT		file_length;			// ļȣλΪKB
	UINT		disk_no;				// ڵӲ̺
	UINT		disk_part;				// ڵķ
	UINT		first_clus_no;			// ļ״غ
	UINT		ud_no;					// ûݺ
	BYTE		base_name[24];			// ļ
	BYTE		ext_name[4];			// չ
	UINT		checked;				// ǷѡУļ
}FILE_INFO,*pFILE_INFO;

/* ֡λϢ */
typedef struct
{
	LONGLONG		nFilePos;				// ָ֡ļеƫλ
	LONG			nFrameLen;				// ֡
	LONG			nFrameNum;				// ֡
	LONG			nFrameTime;				// ֡ʱ
	LONG			nErrorFrameNum;			// ʹ
	SYSTEMTIME*		pErrorTime;				// ʹ
	LONG			nErrorLostFrameNum;		// ʹ
	LONG			nErrorFrameSize;		// ʹ
}FRAME_POS,*PFRAME_POS;

/* ֡Ϣ */
typedef struct
{
	LONG			nWidth;					// λءƵΪ0
	LONG			nHeight;				// ߣƵΪ0
	LONG			nStamp;					// ʱϢλ
	LONG			nType;					// Ƶ֡ͣT_AUDIO16T_RGB32T_IYUV
	LONG			nFrameRate;				// ʱͼ֡
}FRAME_INFO;

/* ֡Ϣչֶ */
typedef struct
{
	#define FRAME_TYPE_VIDEO 0				// Ƶ֡
	#define FRAME_TYPE_AUDIO 1				// Ƶ֡
	int				nFrameType;				// Ƶ֡ͣ涨
	int				nFrameSeq;				// ֡
	int				nStamp;					// ʱϢλ
	int				nWidth;					// λءƵΪ0
	int 			nHeight;				// ߣƵΪ0
	int				nFrameRate;				// ʱͼ֡
	int				nChannels;				// Ƶͨ
	int				nBitPerSample;			// Ƶλ
	int				nSamplesPerSec;			// ƵƵ
	int				nRemainData;			// ʣ
	SYSTEMTIME		nDataTime;				// ʱ
	int				nReserved[59];			// ֶ
}FRAME_INFO_EX;

/* ֡Ϣ */
typedef struct 
{
	int				nFrameType;					// ֡ͣFRAME_INFO_EXnFrameTypeֶ
	void*			pAudioData;				    // ƵݣƵ֡
	int				nAudioDataLen;			    // Ƶݳ
	void*			pVideoData[3];			    // ֱʾƵYUV
	int				nStride[3];				    // ֱʾYUVĿ
	int				nWidth[3];				    // ֱʾYUVĿ
	int				nHeight[3];					// ֱʾYUVĸ߶
	int				nReserved[64];				// ֶ
}FRAME_DECODE_INFO;

/* ýϢ */
typedef struct 
{
	int			lWidth;					//	λ
	int			lHeight;				//	
	int			lFrameRate;				//	֡
	int			lChannel;				//	Ƶͨ
	int			lBitPerSample;			//	Ƶλ
	int			lSamplesPerSec;			//	ƵƵ
}MEDIA_INFO;

/***********************************************************************************************/
/* ӿ																						   */
/***********************************************************************************************/

/************************************************************************/
//> ȡ汾
/************************************************************************/

/**
 * ȡſSDK汾ţΰ汾źͲš
 *
 * @return 16λʾǰ汾ţ9~16λʾΰ汾ţ1~8λʾβš
 *         磺ֵ0x00030107ʾ汾3ΰ汾17
 */
PLAYSDK_API DWORD CALLMETHOD PLAY_GetSdkVersion();

/************************************************************************/
//> 
/************************************************************************/

/**
 * ȡ롣
 *
 * @return 
 */
PLAYSDK_API DWORD  CALLMETHOD PLAY_GetLastErrorEx();

/************************************************************************/
//> Ŷ˿ں
/************************************************************************/

/**
 * ȡͨţΧ101~511
 *
 * @param[out] plPort ȡĿͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetFreePort(LONG *plPort);

/**
 * ͷͨš
 *
 * @param[in] lPort ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_ReleasePort(LONG lPort);

/************************************************************************/
//> ļ
/************************************************************************/

/**
 * 򿪲ļ
 *
 * @param[in] nPort ͨ
 * @param[in] sFileName ļ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_OpenFile(LONG nPort,LPSTR sFileName);

/**
 * رļ
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_CloseFile(LONG nPort);

/**
 * ļص
 *
 * @param[in] nPort ͨ
 * @param[in] pUserData û
 */
typedef void (CALLBACK *fFileEndCBFun)(DWORD nPort, void* pUserData);

/**
 * ļص
 *
 * @param[in] nPort ͨ
 * @param[out] pFileEndCBFun ļصָ
 * @param[in] pUserData û
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetFileEndCallBack(LONG nPort, fFileEndCBFun pFileEndCBFun, void* pUserData);

/************************************************************************/
//> 
/************************************************************************/

/**
 * ģʽ
 *
 * @param[in] nPort ͨ
 * @param[in] nMode ģʽ0ʵʱ1ļ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetStreamOpenMode(LONG nPort,DWORD nMode);

/**
 * ȡģʽ
 *
 * @param[in] nPort ͨ
 * @return LONGSTREAM_MODE_REALSTREAMSTREAM_MODE_FILESTREAM
 */
PLAYSDK_API LONG CALLMETHOD PLAY_GetStreamOpenMode(LONG nPort);

/**
 * 
 *
 * @param[in] nPort ͨ
 * @param[in] pFileHeadBuf ļͷ
 * @param[in] nSize ļͷ
 * @param[in] nBufPoolSize òдĻСΧSOURCE_BUF_MIN~SOURCE_BUF_MAX
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_OpenStream(LONG nPort,PBYTE pFileHeadBuf,DWORD nSize,DWORD nBufPoolSize);

/**
 * ر
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_CloseStream(LONG nPort);

/**
 * PLAY_Play֮ʹá
 *
 * @param[in] nPort ͨ
 * @param[in] pBuf ݻַ
 * @param[in] nSize ݳ
 * @return BOOLɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_InputData(LONG nPort,PBYTE pBuf,DWORD nSize);


/************************************************************************/
//> 
/************************************************************************/

/**
 * Զռʽ
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_PlaySound(LONG nPort);

/**
 * رռʽ
 *
 * @return BOOLɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StopSound();

/**
 * Թʽ
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_PlaySoundShare(LONG nPort);

/**
 * رʽ
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StopSoundShare(LONG nPort);

/**
 * 
 *
 * @param[in] nPort ͨ
 * @param[in] nVolume ֵΧ0-0xFFFF
 * @return BOOLɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetVolume(LONG nPort,WORD nVolume);

/**
 * ȡ
 *
 * @param[in] nPort ͨ
 * @return WORDֵ
 * @note ָӰ쵽Ӧá
 */
PLAYSDK_API WORD CALLMETHOD PLAY_GetVolume(LONG nPort);

/**
 * Ƶɼݻص
 *
 * @param[in] pDataBuffer ݵַ
 * @param[in] DataLength ݳ
 * @param[in] pUserData û
 */
typedef void (CALLBACK *pCallFunction)(LPBYTE pDataBuffer, DWORD DataLength, void* pUserData);

/**
 * Ƶɼܡ
 *
 * @param[in] pProcƵɼݻصָ
 * @param[in] nBitsPerSample Ƶλ
 * @param[in] nSamplesPerSec Ƶ
 * @param[in] nLength ݻĳȣΧ320-4096
 * @param[in] encodetype Բɼݽбã0pcm1g711a2g711upcmصݣg711ag711uصϴͷ
 * @return BOOLɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_OpenAudioRecord(pCallFunction pProc, LONG nBitsPerSample, LONG nSamplesPerSec, LONG nLength, LONG encodetype, void* pUserData);

/**
 * رƵɼܡ
 *
 * @return BOOLɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_CloseAudioRecord();

/**
 * Ƶɼű
 *
 * @param[in] fRatio ű0С1ΪƵС1ΪԭʼƵ1ΪƵŴ
 * @return BOOLɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetAudioRecScaling(float fRatio);

/**
 * ȡƵɼű
 *
 * @param[out] pfRatio ű0С1ΪƵС1ΪԭʼƵ1ΪƵŴ
 * @return BOOLɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetAudioRecScaling(float* pfRatio);

/**
 * Ƶű
 *
 * @param[in] nPort ͨ
 * @param[in] fRatio ű0С1ΪƵС1ΪԭʼƵ1ΪƵŴ
 * @return BOOLɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetAudioRenderScaling(LONG nPort, float fRatio);

/**
 * ȡƵű
 *
 * @param[in] nPort ͨ
 * @param[out] pfRatio ű0С1ΪƵС1ΪԭʼƵ1ΪƵŴ
 * @return BOOLɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetAudioRenderScaling(LONG nPort, float* pfRatio);

/**
 * WAVEΣԸıĴСPLAY_SetVolumeĲͬڣǵݣֻԸ·ãPLAY_SetVolume
 *  ϵͳá
 *
 * @param[in] nPort ͨ
 * @param[in] nCoefficient 0ǲȡֵΧMIN_WAVE_COEFMAX_WAVE_COEF趨ΪMIN_WAVE_COEF
 *                         ʾͣ趨ΪMAX_WAVE_COEFʾ
 * @return BOOLɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_AdjustWaveAudio(LONG nPort,LONG nCoefficient);

/************************************************************************/
//> ſ
/************************************************************************/

/**
 * šſʼƵСhWndڵҪȫʾֻҪhWndڷŴȫʼ̣߳ʾ   
 * ھΪNULLʾǲӰ롣
*
* @param[in] nPort ͨ
* @param[in] hWnd ƵĴھ
* @return BOOLɹTUREʧܷFALSE
* @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_Play(LONG nPort, HWND hWnd);

/**
 * رղš
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_Stop(LONG nPort);

/**
 * ͣ/ָš
 *
 * @param[in] nPort ͨ
 * @param[in] nPause 1ͣ0ָ
 * @return ɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_Pause(LONG nPort,DWORD nPause);

/**
 * ٲšÿεýʹǰٶһҪָŵPLAY_Play()ӵǰλÿʼš
 * ٶȷΧΪ[1/64,64]
 *
 * @param[in] nPort ͨ
 * @return ɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_Slow(LONG nPort);

/**
 * ٲšÿεýʹǰٶȼӿһҪָŵPLAY_Play()ӵǰλÿʼ 
   ţڸ߱ٲʱܵʾƣܴﲻõٶȡ
 * ٶȷΧΪ[1/64, 64]
 *
 * @param[in] nPort ͨ
 * @return ɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_Fast(LONG nPort);

/**
 * ֡šҪָŵPLAY_ Play
 *
 * @param[in] nPort ͨ
 * @return ɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_OneByOne(LONG nPort);

/**
 * ֡šҪָŵPLAY_ Playֻ֧ļţұļ֮ܵá
 *
 * @param[in] nPort ͨ
 * @return ɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_OneByOneBack(LONG nPort);

/**
 * Ƶ
 *
 * @param[in] nPort ͨ
 * @param[in] nRegionNum ʾֻһʾ(ͨ)Ϊ0
 * @param[in] nBrightness ȡĬ64Χ0-128
 * @param[in] nContrast ԱȶȡĬ64Χ0-128
 * @param[in] nSaturation ͶȡĬ64Χ0-128
 * @param[in] nHue ɫĬ64Χ0-128
 * @return ɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetColor(LONG nPort, DWORD nRegionNum, int nBrightness, int nContrast, int nSaturation, int nHue);

/**
 * ȡƵ
 *
 * @param[in] nPort ͨ
 * @param[in] nRegionNum ʾ
 * @param[out] pBrightness 
 * @param[out] pContrast Աȶ
 * @param[out] pSaturation Ͷ
 * @param[out] pHue ɫ
 * @return ɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetColor(LONG nPort, DWORD nRegionNum, int *pBrightness, int *pContrast, int *pSaturation, int *pHue);

/**
 * ƵŲԡ
 *
 * @param[in] nPort ͨ
 * @param[in] nAVSyncType Ż׼AV_SYNC_TYPE
 * @return ɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetAVSyncType(LONG nPort,AV_SYNC_TYPE nAVSyncType);

/**
 * ıƵٶȡڷ1Ƶᱻ
 *
 * @param[in] nPort ͨ
 * @param[in] fCoff ٶȣΧ1/64-64ٶȽϿʱҪ֡
 * @return ɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlaySpeed(LONG nPort, float fCoff);

/**
 * òŷ
 *
 * @param[in] nPort ͨ
 * @param[in] emDirection ŷ0ţ1
 * @return ɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayDirection(LONG nPort, DWORD emDirection);

/**
 * ӳٲʱ䡣[nDelay,nThreshold]СnDelay΢ţnThreshold΢ţ֮š
 *
 * @param[in] nPort ͨ
 * @param[in] nDelay(ms) ӳʱ䡣ﵽʱţСڸʱ΢
 * @param[in] nThreshold(ms) ֵʱ䡣Сڸʱţڸʱ΢
 * @return ɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDelayTime(LONG nPort, int nDelay, int nThreshold);

/**
 * òŲԣֻʵʱЧ
 *
 * @param[in] nPort ͨ
 * @param[in] nStartTime(ms) ʼʱ
 * @param[in] nSlowTime(ms) ֵʱ䡣Сڸʱţڸʱ΢
 * @return ɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayMethod(LONG nPort, int nStartTime, int nSlowTime, int nFastTime, int nFailedTime);

/**
 * ͼתΧ0-3
 *
 * @param[in] nPort ͨ
 * @param[in] nrotateType ת͡0ת1ת90ȣ2ת180ȣ3ת270
 * @return ɹTUREʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetRotateAngle(LONG nPort , int nrotateType);

/************************************************************************/
//> ļλ
/************************************************************************/

/**
 * ļָλ(ٷֱ)
 *
 * @param[in] nPort ͨ
 * @param[in] fRelativePos ļȵİٷֱ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayPos(LONG nPort,float fRelativePos);

/**
 * ȡļָλ(ٷֱ)
 *
 * @param[in] nPort ͨ
 * @return floatļȵλãΧ0-100%
 */
PLAYSDK_API float CALLMETHOD PLAY_GetPlayPos(LONG nPort);

/**
 * ļǰʱ䡣
 *
 * @param[in] nPort ͨ
 * @param[in] nTime ļλõָʱ䣬λ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayedTimeEx(LONG nPort,DWORD nTime);

/**
 * ȡļǰʱ䡣
 *
 * @param[in] nPort ͨ
 * @return DWORDļǰŵʱ䣬λ
 */
PLAYSDK_API DWORD CALLMETHOD PLAY_GetPlayedTimeEx(LONG nPort);

/**
 * ȡǰŵ֡ţPLAY_GetPlayedFramesܹ֡ļ
 * λòı䣬ôķֵӦ÷ǳӽʧ
 * ݡ
 *
 * @param[in] nPort ͨ
 * @return DWORDǰŵ֡
 */
PLAYSDK_API DWORD CALLMETHOD PLAY_GetCurrentFrameNum(LONG nPort);

/**
 * ļǰ֡֡ţ˺ļ֮ܵá
 *
 * @param[in] nPort ͨ
 * @param[in] nFrameNum ֡
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetCurrentFrameNum(LONG nPort,DWORD nFrameNum);

/**
 * ȡѲŵ֡
 *
 * @param[in] nPort ͨ
 * @return DWORDѾŵƵ֡
 */
PLAYSDK_API DWORD CALLMETHOD PLAY_GetPlayedFrames(LONG nPort);

/**
 * ȡǰļʱ䡣
 *
 * @param[in] nPort ͨ
 * @return DWORDļǰŵʱ䣬λ
 */
PLAYSDK_API DWORD CALLMETHOD PLAY_GetPlayedTime(LONG nPort);

/**
 * ȡļʱ䡣
 *
 * @param[in] nPort ͨ
 * @return DWORDļܵʱ䳤ֵλ
 */
PLAYSDK_API DWORD CALLMETHOD PLAY_GetFileTime(LONG nPort);

/**
 * ȡļ֡
 *
 * @param[in] nPort ͨ
 * @return DWORDļе֡
 */
PLAYSDK_API DWORD CALLMETHOD PLAY_GetFileTotalFrames(LONG nPort);

/************************************************************************/
//> ļ
/************************************************************************/

/**
 * ص
 *
 * @param[in] nPort ͨ
 * @param[in] pUserData ûԶ
 */
typedef void(CALLBACK *fFileRefDoneCBFun)(DWORD nPort, void* pUserData);	

/**
 * ýصļʱļ̺ʱȽϳԼ
 * ÿ봦40MҵݣΪӲ̶ݱȽĹ
 * ̨ɣҪʹĺҪȴ̽ӿڲӰ졣
 *
 * @param[in] nPort ͨ
 * @param[out] pFileRefDoneCBFun صָ
 * @param[in] pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetFileRefCallBack(LONG nPort,
													fFileRefDoneCBFun pFileRefDoneCBFunc,
													void* pUserData);
/**
 * ص
 *
 * @param[in] nPort ͨ
 * @param[in] bIndexCreated ־TRUEɹFALSEʧ
 * @param[in] pUserData ûԶ
 */
typedef void (CALLBACK *fFileRefDoneCBFunEx)(DWORD nPort, BOOL bIndexCreated, void* pUserData);

/**
 * ýصļʱļ̺ʱȽϳԼ
 * ÿ봦40MҵݣΪӲ̶ݱȽĹ
 * ̨ɣҪʹĺҪȴ̽ӿڲӰ졣
 *
 * @param[in] nPort ͨ
 * @param[out] pFileRefDoneCBFunEx صָ
 * @param[in] pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetFileRefCallBackEx(LONG nPort, fFileRefDoneCBFunEx pFileRefDoneCBFunEx, void* pUserData);

/**
 * ָλ֮ǰĹؼ֡λãͼӹؼ֡ʼû
 * ļǴӹؼ֡ʼģôһؼ֮֡ǰݻᱻԡ
 * ûҪȡļеһݣӦÿǴӹؼ֡ʼȡλ
 * ϵඪʧ3֡ݡļȫǰ£
 * PLAY_GetNextKeyFramePosʹãʵּ¼ļ
 * ؼ֡йء
 *
 * @param[in] nPort ͨ
 * @param[in] nValue ǰλãʱ֡ţnTypeָ
 * @param[in] nType ָnValue͡nTypeBY_FRAMENUMnValueʾ֡ţnTypeBY_FRAMTIMEnValueʾʱ䣬λms
 * @param[in] pFramePos ҵĹؼ֡ļλϢṹָ룬PFRAME_POS
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetKeyFramePos(LONG nPort,DWORD nValue, DWORD nType, PFRAME_POS pFramePos);

/**
 * ָλ֮Ĺؼ֡λá
 *
 * @param[in] nPort ͨ
 * @param[in] nValue ǰλãʱ֡ţnTypeָ
 * @param[in] nType ָnValue͡nTypeBY_FRAMENUM,nValueʾ֡ţnTypeBY_FRAMTIME,nValueʾʱ,λms
 * @param[in] pFramePos ҵĹؼ֡ļλϢṹָ룬PFRAME_POS
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetNextKeyFramePos(LONG nPort,DWORD nValue, DWORD nType, PFRAME_POS pFramePos);

/**
 * ȡļԱ´δͬһļʱֱʹϢɺܻϢ
 *
 * @param[in] nPort ͨ
 * @param[in] pBuffer Ϣ
 * @param[in/out] pSize pBufferĴСϢСڵһָpSize=0pBuffer=NULL
 *                  pSizeķֵҪĻСȻ㹻Ļ壬ٵһΡ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetRefValue(LONG nPort,BYTE *pBuffer, DWORD *pSize);

/**
 * ļϢ䳤ȱ׼ȷѾļϢ
 * ٵĻصPLAY_SetFileRefCallBackExֱϢ
 *
 * @param[in] nPort ͨ
 * @param[in] pBuffer Ϣ
 * @param[in] pSize Ϣĳ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetRefValue(LONG nPort,BYTE *pBuffer, DWORD nSize);

/************************************************************************/
//> ȡŻϢ
/************************************************************************/

/**
 * ýصͣPLAY_Play֮ǰá
 *
 * @param[in] nPort ͨ
 * @param[in] nStream 1 Ƶ2 Ƶ3 
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecCBStream(LONG nPort,DWORD nStream);

/**
 * ص
 *
 * @param[in] nPort ͨ
 * @param[in] pFrameDecodeInfo Ƶ
 * @param[in] pFrameInfo ͼϢμFRAME_INFOṹ
 * @param[in] pUser ûԶ
 */
typedef void (CALLBACK* fCBDecode)(LONG nPort, FRAME_DECODE_INFO* pFrameDecodeInfo, FRAME_INFO_EX* pFrameInfo, void* pUser);

/**
 * ýص滻еʾ֣ûԼʾú
 * PLAY_Play֮ǰãPLAY_StopʱԶʧЧ´εPLAY_Play֮ǰ
 * Ҫá벿ֲٶȣֻҪûӻصзأ
 * ͻһݡֻ벻ʾΡ
 *
 * @param[in] nPort ͨ
 * @param[out] cbDec صָ룬ΪNULL
 * @param[in] pUser ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecodeCallBack(LONG nPort, fCBDecode cbDec, void* pUser);

/**
 * Ƶץͼص
 *
 * @param[in] nPort ͨ
 * @param[in] pBuf ͼ
 * @param[in] nSize ͼݴС
 * @param[in] nWidth λ
 * @param[in] nHeight ߣλ
 * @param[in] nStamp ʱϢλ
 * @param[in] nType ͣT_RGB32T_UYVY궨˵
 * @param[in] nReceaved ӦûԶ
 */
typedef void (CALLBACK* fDisplayCBFun)(LONG nPort,char * pBuf,LONG nSize,LONG nWidth,LONG nHeight,LONG nStamp,LONG nType, void* pReserved);

/**
 * ƵץͼصҪֹͣص԰ѻصָΪNULLúκʱá
 *
 * @param[in] nPort ͨ
 * @param[out] DisplayCBFun ץͼصΪNULL
 * @param[in] pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDisplayCallBack(LONG nPort, fDisplayCBFun DisplayCBFun, void* pUserData);

/**
 * ƵWAVEݻص
 *
 * @param[in] nPort ͨ
 * @param[in] pAudioBuf waveʽƵ
 * @param[in] nSize Ƶݳ
 * @param[in] nStamp ʱ(ms)
 * @param[in] nType ƵT_AUDIO16 8000ÿ16λʾ
 * @param[in] pUserData ûԶ
 */
typedef void (CALLBACK * fAudioCBFun)(LONG nPort, char * pAudioBuf, LONG nSize, LONG nStamp, LONG nType, void* pUserData);

/**
 * ƵWAVEݻص
 *
 * @param[in] nPort ͨ
 * @param[out] AudioCBFun Ƶص
 * @param[in] pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetAudioCallBack(LONG nPort, fAudioCBFun AudioCBFun, void* pUserData);

/**
 * صPLAY_SetDecodeCallBackͬͬǽصͬʱʾƵ鲻Ҫڻصʱ߼ʾʱ
 *
 * @param[in] nPort ͨ
 * @param[out] cbDec صָ룬ΪNULL
 * @param[in] pUser ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
typedef fCBDecode fVisibleDecodeCallBackFunc;
PLAYSDK_API BOOL CALLMETHOD PLAY_SetVisibleDecodeCallBack(LONG nPort, fVisibleDecodeCallBackFunc cbDec, void* pUser);

/**
 * ص
 *
 * @param[in] nPort ͨ
 * @param[in] pBuf Ƶ
 * @param[in] nSize ƵpBufĳ
 * @param[in] pFrameInfo ͼϢμFRAME_INFOṹ
 * @param[in] pUserData ûԶ
 * @param[in] nReserved2 
 */
typedef void (CALLBACK* fDecCBFun)(LONG nPort,char * pBuf,LONG nSize,FRAME_INFO * pFrameInfo, void* pUserData, LONG nReserved2);

/**
 * ýص滻еʾ֣ûԼʾú
 * PLAY_Play֮ǰãPLAY_StopʱԶʧЧ´εPLAY_Play֮ǰ
 * Ҫá벿ֲٶȣֻҪûӻصзأ
 * ͻһݡֻ벻ʾΡ
 *
 * @param[in] nPort ͨ
 * @param[out] DecCBFun صָ룬ΪNULL
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecCallBack(LONG nPort, fDecCBFun DecCBFun);

/**
 * ýص滻еʾ֣ûԼʾú
 * PLAY_Play֮ǰãPLAY_StopʱԶʧЧ´εPLAY_Play֮ǰ
 * Ҫá벿ֲٶȣֻҪûӻصзأ
 * ͻһݡֻ벻ʾΡ
 *
 * @param[in] nPort ͨ
 * @param[out] DecCBFun صָ,ΪNULL
 * @param[in] pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecCallBackEx(LONG nPort, fDecCBFun DecCBFun, void* pUserData);

/**
 * ص
 *
 * @param[in] nPort ͨ
 * @param[in] pBuf Ƶ
 * @param[in] nSize ƵpBufĳ
 * @param[in] pFrameInfo ͼϢ,μFRAME_INFOṹ
 * @param[in] pUserData ûԶ
 * @param[in] nReserved1 
 */
typedef void (CALLBACK* fVisibleDecCBFun)(LONG nPort,char * pBuf,LONG nSize,FRAME_INFO * pFrameInfo, void* pUserData, LONG nReserved1);

/**
 * صPLAY_SetDecCallBackExͬͬǽصͬʱ
 * ʾƵ鲻Ҫڻصʱ߼ʾʱ
 *
 * @param[in] nPort ͨ
 * @param[out] DecCBFun صָ,ΪNULL
 * @param[in] pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetVisibleDecCallBack(LONG nPort, fVisibleDecCBFun DecCBFun, void* pUserData);

/**
 * ˮӡݻص
 *
 * @param[in] buf ˮӡbufferָ
 * @param[in] key ֲͬˮӡϢ
 * @param[in] len 󳤶
 * @param[in] reallen ʵʳ
 * @param[in] len 󳤶
 * @param[in] reallen ʵʳ
 * @param[in] type 1ûд2ˮӡ3֡ݴ4֡Ŵ
 * @param[in] pUserData ûԶ
 * @return int 
 */
typedef int (CALLBACK* fGetWaterMarkInfoCallbackFunc)(char* buf, LONG key, LONG len, LONG reallen, LONG type, void* pUserData);	

/**
 * ˮӡݻصע⣺ˮӡУصú󽫲нʾ
 *
 * @param[in] nPort ͨ
 * @param[out] pFunc ˮӡصָ
 * @param[in] pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetWaterMarkCallBack(LONG nPort, fGetWaterMarkInfoCallbackFunc pFunc, void* pUserData);

/**
 * ˮӡݻص
 *
 * @param[in] nPort ͨ
 * @param[in] buf ˮӡݻ
 * @param[in] lTimeStamp ˮӡʱ
 * @param[in] lInfoType ˮӡϢ,,WATERMARK_DATA_TEXT,WATERMARK_DATA_JPEG_BMP,WATERMARK_DATA_FRAMEDATA
 * @param[in] len 󳤶
 * @param[in] reallen ʵʳ
 * @param[in] lCheckResult 1ûд2ˮӡ3֡ݴ4֡Ŵ
 * @param[in] pUserData ûԶ
 * @return int 
 */
typedef int (CALLBACK* fGetWaterMarkInfoCallbackFuncEx)(LONG nPort, char* buf, LONG lTimeStamp, LONG lInfoType, LONG len, LONG reallen, LONG lCheckResult, void* pUserData);

/**
 * ˮӡݻصע⣺ˮӡУصú󽫲нʾ
 *
 * @param[in] nPort ͨ
 * @param[out] pFunc ˮӡصָ
 * @param[in] pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetWaterMarkCallBackEx(LONG nPort, fGetWaterMarkInfoCallbackFuncEx pFunc, void* pUserData);

/**
 * ͼֱʸı֪ͨص
 *
 * @param[in] nPort ͨ
 * @param[in] pUserData ûԶ
 */
typedef void (CALLBACK *fEncChangeCBFun)(LONG nPort, void* pUserData);

/**
 * ͼֱʸı֪ͨصļǰʹá
 *
 * @param[in] nPort ͨ
 * @param[out] EncChangeCBFun ֱʸı֪ͨص
 * @param[in] pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetEncTypeChangeCallBack(LONG nPort, fEncChangeCBFun EncChangeCBFun, void* pUserData);

/**
 * ͼֱʸı֪ͨص
 *
 * @param[in] nPort ͨ
 * @param[in] pUserData ûԶ
 * @param[in] nWidth ͼ
 * @param[in] nHeight ͼ
 */
typedef void(CALLBACK *fEncChangeCBFunEx)(LONG nPort, void* pUserData,LONG nWidth, LONG nHeight);

/**
 * ͼֱʸı֪ͨصļǰʹá
 *
 * @param[in] nPort ͨ
 * @param[out] EncChangeCBFun ֱʸı֪ͨص
 * @param[in] pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetEncTypeChangeCallBackEx(LONG nPort, fEncChangeCBFunEx EncChangeCBFun, void* pUserData);

/**
 * ѯϢ
 *
 * @param[in] nPort ͨ
 * @param[in] cmdType ָ״̬ѯָCMD_TYPE_E
 * @param[in] buf ϢĻ
 * @param[in] buflen 峤
 * @param[out] returnlen ȡϢЧݳ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_QueryInfo(LONG nPort, int cmdType, char* buf, int buflen, int* returnlen);

/**
 * ȡƵʵʱʡ
 *
 * @param[in] nPort ͨ
 * @param[out] pBitRate Ƶ(λΪk)
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetRealFrameBitRate(LONG nPort, double* pBitRate);

/**
 * ȡļ֡
 *
 * @param[in] nPort ͨ
 * @return DWORDȡǰ֡
 */
PLAYSDK_API DWORD CALLMETHOD PLAY_GetCurrentFrameRate(LONG nPort);

/**
 * ȡʾͼСۣΪͼ񣩣ݴ˴Сʾڵ򣬿ԲԿ
 * Щ֧ӲŵԿ˵ǳá
 *
 * @param[in] nPort ͨ
 * @param[out] pWidth ͼ
 * @param[out] pHeight ͼ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetPictureSize(LONG nPort,LONG *pWidth,LONG *pHeight);

/**
 * ֡ݻص
 *
 * @param[in] nPort ͨ
 * @param[in] pBuf ָ
 * @param[in] nSize ݳ
 * @param[in] pMutexInfo ֡Ϣ,ָDEMUX_INFOṹ
 * @param[in] pMutexInfoEx ֡ݻݣָDemuInfoExṹ
 * @param[in] pUserData ûԶ
 */
/* Demux֡ */
typedef enum
{
	FRAME_UNKNOWN = 0,			// ֡Ͳ֪
	FRAME_VIDEO,				// ֡Ƶ֡
	FRAME_AUDIO,				// ֡Ƶ֡
	FRAME_DATA					// ֡֡
}FRAME_TYPE;

/* Demux֡ */
typedef enum
{
	FRAME_SUB_TYPE_DATA_INVALID = 0,			// Ч
	FRAME_SUB_TYPE_VIDEO_I_FRAME = 1,			// I֡
	FRAME_SUB_TYPE_VIDEO_P_FRAME,				// P֡
	FRAME_SUB_TYPE_VIDEO_B_FRAME,				// B֡

	FRAME_SUB_TYPE_VIDEO_SMART_I_FRAME = 19,	// smart I֡
	FRAME_SUB_TYPE_VIDEO_SMART_P_FRAME 			// smart P֡
}FRAME_SUB_TYPE;

/* DemuxƵʽ */
typedef enum
{
	ENCODE_VIDEO_UNKNOWN = 0,		// Ƶʽ֪
	ENCODE_VIDEO_MPEG4,				// ƵʽMPEG4
	ENCODE_VIDEO_HI_H264,			// ƵʽǺ˼H264
	ENCODE_VIDEO_JPEG,				// ƵʽǱ׼JPEG
	ENCODE_VIDEO_DH_H264,			// ƵʽǴH264
	ENCODE_VIDEO_JPEG2000 = 6,		// ƵʽǱ׼JPEG2000
	ENCODE_VIDEO_AVS = 7,			// ƵʽǱ׼AVS
	ENCODE_VIDEO_STD_H264 = 8,		// ƵʽǱ׼H264
	ENCODE_VIDEO_MPEG2 = 9,			// ƵʽMPEG2
	ENCODE_VIDEO_VNC = 10,			// ƵʽVNC
	ENCODE_VIDEO_SVAC = 11,			// ƵʽSVAC
	ENCODE_VIDEO_DH_H265 = 12		// ƵʽH265
}ENCODE_VIDEO_TYPE;

/* DemuxƵʽ */
typedef enum 
{
	ENCODE_AUDIO_UNKNOWN = 0,
	ENCODE_AUDIO_PCM = 7,			// ƵʽPCM8
	ENCODE_AUDIO_G729,				// ƵʽG729
	ENCODE_AUDIO_IMA,				// ƵʽIMA
	ENCODE_PCM_MULAW,				// ƵʽPCM MULAW
	ENCODE_AUDIO_G721,				// ƵʽG721
	ENCODE_PCM8_VWIS,				// ƵʽPCM8_VWIS
	ENCODE_MS_ADPCM,				// ƵʽMS_ADPCM
	ENCODE_AUDIO_G711A,				// ƵʽG711A
	ENCODE_AUDIO_AMR,				// ƵʽAMR
	ENCODE_AUDIO_PCM16,				// ƵʽPCM16
	ENCODE_AUDIO_G711U = 22,		// ƵʽG711U
	ENCODE_AUDIO_G723 = 25,			// ƵʽG723
	ENCODE_AUDIO_AAC,				// ƵʽAAC
	ENCODE_AUDIO_G726_40,           // ƵʽG726, 40kbps
	ENCODE_AUDIO_G726_32,           // ƵʽG726, 32kbps
	ENCODE_AUDIO_G726_24,           // ƵʽG726, 24kbps
	ENCODE_AUDIO_G726_16,           // ƵʽG726, 16kbps
	ENCODE_AUDIO_MP2,				// Ƶʽmp2
	ENCODE_AUDIO_OGG,				// Ƶʽogg vorbis
	ENCODE_AUDIO_MP3,				// Ƶʽmp3
	ENCODE_AUDIO_G722_1,		    // ƵʽG722_1
	ENCODE_AUDIO_OPUS = 38          // ƵʽOPUS
}ENCODE_AUDIO_TYPE;

/* DemuxչϢ */
typedef struct 
{
	char*	pHead;				// ֡(ͷ)
	int		nLen;				// ֡ݳ
	char*	pBody;				// (ͷ)
	int		nBodyLen;			// ݳ

	int		nRet;				// 0: 1:룬ĬΪ0
	BYTE	nEncryptType;		// ͣ0: 1:AES
	char	reserved[127];      // ֶ
}DemuInfoEx;

/* DemuxϢ */
typedef struct
{
	int type;			 // FRAME_TYPE
	int subtype;		 // FRAME_SUB_TYPE
	int encode;			 // ENCODE_VIDEO_TYPEENCODE_AUDIO_TYPE
	int sequence;		 // ֡
	int width;			 // Ƶ
	int height;			 // Ƶ
	int rate;			 // ֡
	int year;			 // ʱ
	int month;           // ʱ
	int day;             // ʱ
	int hour;            // ʱʱ
	int minute;          // ʱ
	int secode;          // ʱ
	LONG timestamp;      // ʱ
	int channels;        // Ƶͨ
	int bitspersample;   // Ƶ
	int samplespersecond;// Ƶ
}DEMUX_INFO;

typedef void (CALLBACK* fDemuxDecCBFun)(LONG nPort,char * pBuf,	LONG nSize,void * pMutexInfo,void* pMutexInfoEx, void* pUserData);

/**
 * ֡ݻص
 *
 * @param[in]  nPort ͨ
 * @param[out] DecCBFun ֡ݻص
 * @param[in]  pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDemuxCallBack(LONG nPort, fDemuxDecCBFun DecCBFun, void* pUserData);

/**
 * aesԿ
 *
 * @param[in] nPort ͨ
 * @param[in] szKey Կָ
 * @param[in] nKeylen Կĳ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetSecurityKey(LONG nPort,const char* szKey,DWORD nKeylen);

/************************************************************************/
//> ʾ
/************************************************************************/

/**
 * ûʾ򣬿ֲŴʾ
 *
 * @param[in] nPort ͨ
 * @param[in] nRegionNum ʾ,0~(MAX_DISPLAY_WND-1),Ϊ0,õʾ
 * @param[in] pSrcRect ֲʾ
 * @param[in] hDestWnd ʾھ
 * @param[in] bEnable ()رʾ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDisplayRegion(LONG nPort,DWORD nRegionNum, DISPLAYRECT *pSrcRect, HWND hDestWnd, BOOL bEnable);

/**
 * ˢʾûͣʱˢ˴ڣ򴰿еͼΪˢ¶ʧ
 * ʱӿڿ°ͼʾֻͣ͵֡ʱ
 * ִУֱӷء
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_RefreshPlay(LONG nPort);

/************************************************************************/
//> 
/************************************************************************/

/**
 *  ȡģʽԴʣݴС(λΪֽ)
 *
 * @param[in] nPort ͨ
 * @return DWORDǰԴĴСλBYTE(λΪֽ)
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API DWORD CALLMETHOD PLAY_GetSourceBufferRemain(LONG nPort);

/**
 * ģʽԴʣݡ
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_ResetSourceBuffer(LONG nPort);

/**
 * ģʽԴʣݡ
 *
 * @param[in] nPort ͨ
 * @param[in] nBufType£
 *			BUF_VIDEO_SRC 1 ƵԴ
 *			BUF_AUDIO_SRC 2 ƵԴ
 *			BUF_VIDEO_RENDER 3 Ƶݻ
 *			BUF_AUDIO_RENDER 4 Ƶݻ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_ResetBuffer(LONG nPort,DWORD nBufType);

/**
 * ȡָĴС
 *
 * @param[in] nPort ͨ
 * @param[in] nBufType£
 *			BUF_VIDEO_SRC 1 ƵԴ
 *			BUF_AUDIO_SRC 2 ƵԴ
 *			BUF_VIDEO_RENDER 3 Ƶݻ
 *			BUF_AUDIO_RENDER 4 Ƶݻ
 * @return DWORDݲͬػֵԴbyte󻺳֡
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API DWORD CALLMETHOD PLAY_GetBufferValue(LONG nPort,DWORD nBufType);

/************************************************************************/
//> Ӳ
/************************************************************************/

/**
 * ʼӲ(Windows32ƽ̨)
 *
 * @return UINTɹӲ ʧܷ0
 */
PLAYSDK_API UINT CALLMETHOD PLAY_InitDisk();

/**
 * Ȼص
 *
 * @param[in] nPort ͨ
 * @param[in] nPercent Ȱٷֱ, -1ʾ쳣
 * @param[in] pUserData ûԶ
 */
typedef void (CALLBACK *fPercentCallbackFunc)(LONG nPort, int nPercent, void* pUserData);

/**
 * Ȼص趨ļʼʱ䣬ָҪPLAY_SetFileRefCallBackصЧ[0,0] ʾļСҪPLAY_OpenFile֮á
 *
 * @param[in] nPort ͨ
 * @param[in] nStartTime ļʼʱ䣬 λΪ1970/1/1ʼ
 * @param[in] nEndTime ļʱ䣬 λΪ1970/1/1ʼ
 * @param[out] pFunCallback Ȼصָ
 * @param[in] pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPercentCallBack(LONG nPort, LONG nStartTime, LONG nEndTime, fPercentCallbackFunc pFunCallback, void* pUserData);

typedef enum
{
	FORMAT_ALL_DATA, //
	FORMAT_KEY_DATA  //ؼ
}FormatType;

/**
 * ʽӲ(Windows32ƽ̨)
 *
 * @param[in] disk_no ҪȡϢĴ̺
 * @param[in] type ʽѡ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_FormatDisk(UINT disk_no, FormatType type);

/**
 * ļѯ붨λ(Windows32ƽ̨)
 *
 * @param[in] channel Ҫѯ¼ͨ
 * @param[in] start_time ¼ѯĿʼʱ
 * @param[in] end_time ¼ѯĽʱ
 * @param[in/out] pmax_ret_num ѯļزѯļļϵͳһηpmax_ret_num
 * @param[out] pfile_info ѯ¼ļŵλ
 * @param[in] type ѯ¼룬졢ͨ
 * @param[in] hint ʱ壬̶Ϊ0
 * @param[in] driver_type 룬ָĳЩڲѯ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API UINT CALLMETHOD PLAY_QueryFileList(UINT nChannel,DHTIME start_time,DHTIME end_time,UINT *pmax_ret_num,pFILE_INFO pfile_info,UINT type, BYTE hint, UINT driver_type);

/************************************************************************/
//> 
/************************************************************************/

typedef enum
{
	FISHEYEMOUNT_MODE_INVALID = 0,					// װģʽЧ
	FISHEYEMOUNT_MODE_CEIL = 1,						// װ
	FISHEYEMOUNT_MODE_WALL,							// װ
	FISHEYEMOUNT_MODE_FLOOR,						// װ
	FISHEYEMOUNT_MODE_NUM
}FISHEYE_MOUNTMODE;

typedef enum
{
	FISHEYECALIBRATE_MODE_INVALID = 0,							// ģʽЧ
	FISHEYECALIBRATE_MODE_OFF = 1,								// ر㷨⣬ⲿر
	FISHEYECALIBRATE_MODE_ORIGINAL,								// ԭʼģʽ(),ű
	FISHEYECALIBRATE_MODE_PANORAMA,								// 1p
	FISHEYECALIBRATE_MODE_PANORAMA_PLUS_ONE_EPTZ,				// 1p+1
	FISHEYECALIBRATE_MODE_DOUBLE_PANORAMA,						// 2p
	FISHEYECALIBRATE_MODE_ORIGINAL_PLUS_DOUBLE_PANORAMA,		// 1+2p
	FISHEYECALIBRATE_MODE_ORIGINAL_PLUS_THREE_EPTZ_REGION,		// 1+3
	FISHEYECALIBRATE_MODE_PANORAMA_PLUS_THREE_EPTZ_REGION,		// 1p+3
	FISHEYECALIBRATE_MODE_ORIGINAL_PLUS_TWO_EPTZ_REGION,		// 1+2
	FISHEYECALIBRATE_MODE_ORIGINAL_PLUS_FOUR_EPTZ_REGION,		// 1+4
	FISHEYECALIBRATE_MODE_PANORAMA_PLUS_FOUR_EPTZ_REGION,		// 1p+4
	FISHEYECALIBRATE_MODE_PANORAMA_PLUS_SIX_EPTZ_REGION,		// 1p+6
	FISHEYECALIBRATE_MODE_ORIGINAL_PLUS_EIGHT_EPTZ_REGION,		// 1+8
	FISHEYECALIBRATE_MODE_PANORAMA_PLUS_EIGHT_EPTZ_REGION,		// 1p+8
	FISHEYECALIBRATE_MODE_TWO_EPTZ_REGION_WITH_ORIGINAL,		// 1F+2	
	FISHEYECALIBRATE_MODE_FOUR_EPTZ_REGION_WITH_ORIGINAL,		// 1F+4	
	FISHEYECALIBRATE_MODE_DOUBLE_PANORAMA_WITH_ORIGINAL,		// 1F+2p
	FISHEYECALIBRATE_MODE_FOUR_EPTZ_REGION_WITH_PANORAMA,		// 1p(F)+4
	FISHEYECALIBRATE_MODE_TWO_EPTZ_REGION,		                // 2
	FISHEYECALIBRATE_MODE_SINGLE,								// 
	FISHEYECALIBRATE_MODE_FOUR_EPTZ_REGION,						// 4
	FISHEYECALIBRATE_MODE_USER_DEFINED,				    		// ûԶ
	FISHEYECALIBRATE_MODE_PHONE,								// ֻģʽ
	FISHEYECALIBRATE_MODE_ORIGINAL_PLUS_ONE_EPTZ_REGION,		// 1+1
	FISHEYECALIBRATE_MODE_ONE_EPTZ_REGION,						// 1
	FISHEYECALIBRATE_MODE_SEMI_SPHERE,							// Բ
	FISHEYECALIBRATE_MODE_CYLINDER,								// Բ
	FISHEYECALIBRATE_MODE_LITTLE_PLANET,						// С
	FISHEYECALIBRATE_MODE_DOUBLE_SPHERE,						// ˫Ŀ
	FISHEYECALIBRATE_MODE_DOUBLE_CYLINDER,						// ˫ĿԲ
	FISHEYECALIBRATE_MODE_DOUBLE_360,

	FISHEYECALIBRATE_MODE_NUM
}FISHEYE_CALIBRATMODE;

typedef enum
{
	FISHEYEEPTZ_CMD_INVALID = 0,	
	FISHEYEEPTZ_CMD_ZOOM_IN = 1,						// Ŵ
	FISHEYEEPTZ_CMD_ZOOM_OUT,							// С
	FISHEYEEPTZ_CMD_UP,									// ƶ
	FISHEYEEPTZ_CMD_DOWN,								// ƶ
	FISHEYEEPTZ_CMD_LEFT,								// ƶ
	FISHEYEEPTZ_CMD_RIGHT,								// ƶ
	FISHEYEEPTZ_CMD_ROTATE_CLOCKWISE_AUTO,				// Զ˳ʱת
	FISHEYEEPTZ_CMD_ROTATE_ANTICLOCKWISE_AUTO,			// Զʱת
	FISHEYEEPTZ_CMD_STOP,								// ֹͣ
	FISHEYEEPTZ_CMD_SHOW_REGION,						// ѡŴ
	FISHEYEEPTZ_CMD_EXIT_SHOW_REGION,					// ˳ѡŴ
	FISHEYEEPTZ_CMD_DEFAULT,						    // ָĬ
	FISHEYEEPTZ_CMD_ORIGIN_ROTATE,						// Բת

	FISHEYEEPTZ_CMD_SET_CUR_REGION = 0x20,              // ָڵλϢ
	FISHEYEEPTZ_CMD_GET_CUR_REGION,                     // ȡָڵλϢ
	FISHEYEEPTZ_CMD_IS_IN_PANORAMA_REGION,              // Ƿڵǰȫ
	FISHEYEEPTZ_CMD_TAP_VIEW,							// ʾָλ,㼴
	FISHEYEEPTZ_CMD_SET_FOCUS,	 				        // ôλϢ
	FISHEYEEPTZ_CMD_GET_FOCUS,							// ȡλϢ

	FISHEYEEPTZ_CMD_PTZ_CALI,							// 궨
	FISHEYEEPTZ_CMD_GET_PTZ_RLT,						// ȡλϢ
	FISHEYEEPTZ_CMD_NUM
}FISHEYE_EPTZCMD;

typedef enum
{
	FISHEYE_SETPARAM,	// ò
	FISHEYE_GETPARAM	// ȡ
}FISHEYE_OPERATETYPE;

typedef enum
{
	/* ǹ */
	IPCTYPE_200WN				= 0,	//
	IPCTYPE_130WN				= 1,
	IPCTYPE_D1WN				= 2,
	IPCTYPE_100WN				= 3,
	IPCTYPE_FE					= 4,	// 

	//
	SPCTYPE_D6501				= 100,	// sonyо65
	HSPCTYPE_D6A2030E			= 101,	// 󻪻о2030E6A
	HSPCTYPE_D65A2030E			= 102	// 󻪻о2030E65A
}CAM_TYPE;

/* ͷ */
typedef enum
{
	LENTYPE_NORM				= 0,	// ޻侵ͷ
	LENTYPE_Lens0361 			= 1,	// 3.6ǹͷ
	LENTYPE_Lens2880			= 2,	// 130ȹǹͷ
	LENTYPE_Lens0362 			= 3,	// 3.6ǹͷ
	LENTYPE_Lens0401 			= 4,	// 4.0ǹͷ

	LENTYPE_TEST1				= 100	// ò
}LEN_TYPE;

typedef struct
{
	int w;
	int h;
}FISHEYE_SIZE;

typedef struct
{
	short x;
	short y;
}FISHEYE_POINT2D;

typedef struct
{
	FISHEYE_MOUNTMODE     subMountMode;			    // ͼװģʽ, ͼУģʽΪûԶģʽʱ, ֵЧ
	FISHEYE_CALIBRATMODE  subCalibrateMode;	        // ͼУģʽ, ͼУģʽΪûԶģʽʱ, ֵЧ
	FISHEYE_SIZE          imgOutput;                // ͼֱ
	FISHEYE_POINT2D       upperLeft;                // ͼƫ
	int					  reserved[3];				// ֽ
}FISHEYE_SUBMODE;

typedef struct
{
	FISHEYE_SIZE          mainShowSize;		        // ݲ, ʾ, 4:3, 16:9, 㷨ݴʺϵŽ¾ﵽñ
	FISHEYE_SIZE          floatMainShowSize;		// ˫bufferʱʹãĿǰʱϵĲڵʾڷֱ, ԲĿ߱ҪΪ1:1װȫĿ߱ҪΪ16:9
	FISHEYE_SIZE          imgOutput;                // ͼֱ(ǰ), ͼУģʽΪûԶģʽʱΪⲿ, ģʽΪڲ
	FISHEYE_SUBMODE*	  subMode;                  // ģʽϢ, ͼУģʽΪûԶģʽʱΪⲿ, ģʽΪڲ
	int		              subModeNum;               // ģʽ, ͼУģʽΪûԶģʽʱΪⲿ, ģʽΪڲ
	int                   outputSizeRatio;		    // ݲ, Уͼű,Q8ʽ,Χ0-256, 256Ϊֱ
	int                   reserved[1];				// ֽ
}FISHEYE_OUTPUTFORMAT;

typedef struct
{
	int x;
	int y;
	int hAngle;
	int vAngle;
	int available;
	int reserved[3];
}FISHEYE_REGIONPARAM;

typedef struct
{
	FISHEYE_REGIONPARAM   regionParam[9];
	int              circularOffset;
	int              panoramaOffset;
	int              useRegionParam;           // Ϊ1ʱЧʹøֵгʼûбϢʱΪ0
	int              reserved[1];
}FISHEYE_MODEINITPARAM;

typedef struct
{	
	/**/
	int zoom_type;							// ģʽ----Ӧ䱶͸ݿѡĿС䱶ģʽ
	int hcam_wax;							// ӦǶxˮƽ
	int hcam_way;							// ӦǶyֱ
	int hcam_wmul;							// ã׼
	int cfg_type;							// ÷ʽĬΪ1ʹòʽ,1ʹò÷ʽ0ʹ豸÷ʽ

	/*  */							         
	/* ͷ */
	int prm_re;								// ͶӰ뾶
	int prm_mul;							// ͶӰ
	int prm_dx;								// xƫ
	int prm_dy;								// yƫ
	int prm_cw;								// CMOSʵʹÿ
	int prm_ch;								// CMOSߣʵʹøߣ

	/* ʹãcfg_typeΪ0ʱøòЧ,Ĭ130ȡ130ǹ200W65 */
	LEN_TYPE mlen_type;						// ͷ
	CAM_TYPE mcam_type;						// 
	CAM_TYPE hcam_type;						// 

	/*  */
	int himg_width;                         // ͼ
	int himg_height;                        // ͼ
	int prm_fax;                            // ˮƽӳ

	/* ĬϵĲ */
	/*  */
	int mcam_fc;							// Ч
	int mcam_cw;							// ͷ
	int mcam_ch;							// ͷ 
	int cam_height;                         // ߶ȣףʱδʹã
	int prm_ma;								// 

	/*  */
	/*  */
	int prm_hw;								// CMOS
	int prm_hh;								// CMOS
	int prm_fo;								// Ч
	int prm_ca;								// Ұ
	int prm_mmul;							// 
}MHFPTZ_CONFIGPARAM;

typedef struct
{
	FISHEYE_SIZE     mainStreamSize;		    // Ӧԭʼߣֱ֮ʱΪǴ˷ֱŶ
	int              originX;					// ͼԲԲĺ, һ0-8192ϵ
	int              originY;					// ͼԲԲ, һ0-8192ϵ
	int              radius;					// ͼԲİ뾶, һ0-8192ϵ
	int              lensDirection;		        // תǶ, Q7ʽ, Χ0-360*128, һΪ0
	FISHEYE_MOUNTMODE     mainMountMode;		// װģʽ
	FISHEYE_CALIBRATMODE  mainCalibrateMode;	// ͼУģʽ
	FISHEYE_MODEINITPARAM modeInitParam;        // ⲿģʽʼϢģʽлָһε״̬,
	FISHEYE_OUTPUTFORMAT *outputFormat;         // ͼϢ
	MHFPTZ_CONFIGPARAM   *configParam;          // ò
	int              enableAutoContrast;        // ԶԱȶ, 0ر, 1, ùܻ㷨ʱ, ҪܺõĻŽ鿪
	int              alphaHistogram;            // ֱͼIIRǿ0-255, Ĭ128, ԽԽοǰ֡
	int              alphaGray;                 // Ҷǿ0-255, Ĭ245, ԽԽԱȶ
	FISHEYE_SIZE     captureSize;		        // Ӧǰģʽµץͼֱ
	int              mhfptzIndex;               // IN 0,1,2....
	int              reserved[1];				// ֽ
}FISHEYE_OPTPARAM;

typedef struct
{
	FISHEYE_EPTZCMD   ePtzCmd;			// ̨˵FISHEYE_EPtzCmd
	int          winId;				    // ҪeptzĴڱţϽwinIdΪ0ҵ							
	int          arg1;
	int          arg2;
	int          arg3;
	int          arg4;
	int          arg5;
	int          arg6;
	int          reserved0[6];			   // ֽ
	void*        pParam;                   // 
	void*        pResult;
	void*        pArg;   

	int          reserved1[7];			   // ֽ
}FISHEYE_EPTZPARAM;

/**
 * Ƶ㷨ܣҪfisheye.dll⡣
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StartFisheye(LONG nPort);

/**
 * /ȡ۲
 *
 * @param[in] nPort ͨ
 * @param[in] operatetype 
 * @param[in/out] pOptParam ۲
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_OptFisheyeParams(LONG nPort, FISHEYE_OPERATETYPE operatetype, FISHEYE_OPTPARAM* pOptParam);

/**
 * ڸģʽ¿رյڶ۴ڡ
 *
 * @param[in] nPort ͨ
 * @param[in] hDestWnd ʾھ
 * @param[in] pOptParam ڶڶӦ۲
 * @param[in] bEnable 򿪻رʾ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_FisheyeSecondRegion(LONG nPort, HWND hDestWnd, FISHEYE_OPTPARAM* pOptParam, BOOL bEnable);

/**
 * eptz(̨ƶ
 *
 * @param[in] nPort ͨ
 * @param[in/out] pEptzParam ڲ
 * @param[in] bSecondRegion ǷΪģʽµĵڶڣ1Ϊ棬Ĭ0
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_FisheyeEptzUpdate(LONG nPort, FISHEYE_EPTZPARAM* pEptzParam, BOOL bSecondRegion);

/**
 * ֹͣƵ㷨ܡ
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StopFisheye(LONG nPort);

/**
 * Ϣص
 *
 * @param[in] nPort ͨ
 * @param[in] byCorrectMode ģʽ
 * @param[in] wRadius 뾶
 * @param[in] wCircleX Բĺ
 * @param[in] wCircleY Բ
 * @param[in] widthRatio 
 * @param[in] heightRatio ߱
 * @param[in] gain 
 * @param[in] denoiseLevel ȼ
 * @param[in] InstallStyle ۰װʽ
 * @param[in] pUserData ûԶ
 */
typedef void (CALLBACK* fFishEyeInfoFun)( 
	LONG nPort,
	BYTE byCorrectMode,
	WORD wRadius,
	WORD wCircleX,
	WORD wCircleY,
	UINT widthRatio,
	UINT heightRatio,
	BYTE gain,
	BYTE denoiseLevel,
	BYTE installStyle,
	void* pUserData );

/**
 * ûȡϢص
 *
 * @param[in] nPort ͨ
 * @param[out] pFishEyeInfoFun Ϣصָ룬ΪNULL
 * @param[in] pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetFishEyeInfoCallBack(LONG nPort, fFishEyeInfoFun pFishEyeInfoFun, void* pUserData);

/************************************************************************/
//> ץͼ
/************************************************************************/

/**
 * ץͼBMPͼƬΪָļPLAY_SetDisplayCallBackõƵ
 * ݻصֻƵݽʱŵãûƵ
 * (ץͼ)нݣͲϵصPLAY_
 * CatchPicһֻץһͼͣ͵֡ʱʵץͼ飺
 * ûʵץͼ(һץһͼ)PLAY_CatchPicõһ
 * ʱڵƵݣPLAY_SetDisplayCallBack
 *
 * @param[in] nPort ͨ
 * @param[in] sFileName ļ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_CatchPic(LONG nPort,char* sFileName);

/**
* ץͼͼƬΪָļPLAY_SetDisplayCallBackõƵ
* ݻصֻƵݽʱŵãûƵ
* (ץͼ)нݣͲϵصPLAY_
* CatchPicExһֻץһͼͣ͵֡ʱʵץͼ飺
* ûʵץͼ(һץһͼ)PLAY_CatchPicExõһ
* ʱڵƵݣPLAY_SetDisplayCallBack
 * @param[in] nPort ͨ
 * @param[in] sFileName ļ
 * @param[in] ePicfomat  ͼƬʽtPicFormats
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_CatchPicEx(LONG nPort,char* sFileName,tPicFormats ePicfomat);

/**
 * ͼʽתΪBMPʽ
 *
 * @param[in] pBuf ͼָ
 * @param[in] nSize ͼݴС
 * @param[in] nWidth ͼ
 * @param[in] nHeight ͼ߶
 * @param[in] nType ͣT_YV12T_UYVY
 * @param[in] sFileName ҪļBMPΪļչ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_ConvertToBmpFile(char * pBuf,LONG nSize,LONG nWidth,LONG nHeight,LONG nType, char *sFileName);

/*
 * ͼʽתΪJPEGʽ
 *
 * @param[in] pYUVBuf ͼָ
 * @param[in] nWidth ͼ
 * @param[in] nHeight ͼ߶
 * @param[in] YUVtype YUVͣT_YV12T_UYVY
 * @param[in] quality ͼƬѹΧ(0, 100]
 * @param[in] sFileName ļ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_ConvertToJpegFile(char *pYUVBuf, LONG nWidth, LONG nHeight, int YUVtype, int quality, char *sFileName);

/**
 * ץȡBMPͼ
 *
 * @param[in] nPort ͨ
 * @param[in] pBmpBuf BMPͼݵĻַû䣬Сbmp ͼС
 *               ƼСsizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+w*h*4
 *        whֱΪͼ
 * @param[in] dwBufSize С
 * @param[out] pBmpSize ȡʵbmpͼС
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetPicBMP(LONG nPort, PBYTE pBmpBuf, DWORD dwBufSize, DWORD* pBmpSize);

/**
 * ץȡBMPͼ
 *
 * @param[in] nPort ͨ
 * @param[in] pBmpBuf   BMPͼݵĻַû䣬Сbmp ͼС
 *   ƼСsizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+w*h*4
 *   whֱΪͼߡ
 * @param[in] dwBufSize С
 * @param[out] pBmpSize ȡʵbmpͼС
 * @param[in] nWidth ָbmpĿ
 * @param[in] nHeight ָbmpĸ
 * @param[in] nRgbType ָRGBʽ 0RGB321RGB24
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetPicBMPEx(LONG nPort, PBYTE pBmpBuf, DWORD dwBufSize, DWORD* pBmpSize, LONG nWidth, LONG nHeight, int nRgbType);

/**
 * ץȡJPEGͼ
 *
 * @param[in] nPort ͨ
 * @param[in] pJpegBuf JPEGͼݵĻַû䣬СJPEGͼС
         ƼСw*h*3/2whֱΪͼ
 * @param[in] dwBufSize С
 * @param[out] pJpegSize ȡʵJPEGͼС
 * @param[in] quality JPEGͼѹȡֵΧΪ(0,100]
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetPicJPEG(LONG nPort, PBYTE pJpegBuf, DWORD dwBufSize, DWORD* pJpegSize, int quality);

/**
 * ץȡTIFFͼ
 *
 * @param[in] nPort ͨ
 * @param[in] pTiffBuf TIFFͼݵĻַû䣬СtiffͼС
   ƼСw*h*3+1024
   whֱΪͼ
 * @param[in] dwBufSize С
 * @param[out] pTiffSize ȡʵTIFFͼС
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetPicTIFF(LONG nPort, PBYTE pTiffBuf, DWORD dwBufSize, DWORD* pTiffSize);

/**
 * ץͼѡʽָߡ
 *
 * @param[in] nPort ͨ
 * @param[in] sFileName ļ
 * @param[in] lTargetWidth ָͼ
 * @param[in] lTargetHeight ָͼ߶
 * @param[in] ePicfomat ͼƬʽtPicFomats
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_CatchResizePic(LONG nPort, char* sFileName, LONG lTargetWidth, LONG lTargetHeight, tPicFormats ePicfomat);

/************************************************************************/
//> ͼص
/************************************************************************/

/*
 *ͼص
 * 
 * @param[in] nPort ͨ
 * @param[in] hDc OffScreen豸
 * @param[in] pUserData ûԶ
 */
typedef void (CALLBACK* fDrawCBFun)(LONG nPort,HDC hDc, void* pUserData);

/*
 * עһصõǰdevice contextDCϻͼ()
 * ͺڴڵĿͻDCϻͼDCǴڿͻDCDirectDraw
 * Off-ScreenDCע⣬ʹoverlay棬ӿЧֱ
 * ϻͼֻҪ͸ɫͲᱻǡ
 *
 * @param[in] nPort ͨ
 * @param[out] DrawFun ͼص
 * @param[in] pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_RigisterDrawFun(LONG nPort, fDrawCBFun DrawCBFun, void* pUserData); 

/*
 *ͼص
 * 
 * @param[in] nPort ͨ
 * @param[in] nReginNum ʾţΧ[0,(MAX_DISPLAY_WND-1)]nRegionNumΪ0
 *   õʾС
 * @param[in] hDc OffScreen豸
 * @param[in] pUserData ûԶ
 */
typedef void (CALLBACK* fDrawCBFunEx)(LONG nPort,LONG nReginNum,HDC hDc, void* pUserData);

/*
 * עһصõǰ(HDC)DCǴڿͻDC
 * DirectDrawOff-ScreenDCע⡣ʹoverlay棬
 * ӿЧoverlayʽֱڴϻͼֻҪ͸ɫͲᱻǡ
 *
 * @param[in] nPort ͨ
 * @param[in] nReginNum ʾţΧ[0,(MAX_DISPLAY_WND-1)]nRegionNumΪ0
 *   õʾ
 * @param[out] DrawFunEx ͼص
 * @param[in] pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_RigisterDrawFunEx(LONG nPort, LONG nReginNum, fDrawCBFunEx DrawFunEx, void* pUserData);

/************************************************************************/
//> ¼ƻת빦
/************************************************************************/

/*
 * ʼԤ¼
 *
 * @param[in] nPort ͨ
 * @param[in] sFileName ¼λ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StartPrepareRecord(LONG nPort,const char* pFileName);

/*
 * ֹͣԤ¼
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StopPrepareRecord(LONG nPort);

/*
 * ʼ¼ֻģʽãPLAY_Play֮á
 *
 * @param[in] nPort ͨ
 * @param[in] sFileName ļ
 * @param[in] idataType 0ʾԭʼƵ1ʾתAVIʽ2ʾתASFʽ3ֶαļ5ʾMP4ļ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StartDataRecord(LONG nPort, char *sFileName, int idataType);

/*
 * ԭʼýӿPLAY_StartDataRecordPLAY_StartDataRecordExʹá
 *
 * @param[in] nPort ͨ
 * @param[in] pBuf 
 * @param[in] nSize С
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_WriteData(LONG nPort, PBYTE pBuf,DWORD nSize);

/*
 * ֹͣ¼
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StopDataRecord(LONG nPort);

/*
 * ص AVIConvertCallback
 *
 * @param[in] nPort ͨ
 * @param[in] lMediaChangeType AVI_MEDIACHANGE_FRAMERATEʾ֡ʸı䣻AVI_MEDIACHANGE_RESOLUTIONʾֱʸı
 * @param[in] pUserData ûԶ
 * @param[out] pIsNewFile TRUE ֶתFALSE ֶΣĬϲֶ
 * @param[out] sNewFileName ֶתµ¼ļ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
typedef void (CALLBACK* fAVIConvertCallback)(LONG nPort, LONG lMediaChangeType, void* pUserData, BOOL *pIsNewFile, char *sNewFileName);

/*
 * ʼAVIתAVIת״̬ص
 *
 * @param[in] nPort ͨ
 * @param[in] sFileName ļ
 * @param[out] pAVIFunc ص
 * @param[in] pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StartAVIConvert(LONG nPort, char *sFileName, fAVIConvertCallback pAVIFunc, void* pUserData);

/*
 * ֹͣAVIת
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StopAVIConvert(LONG nPort);

/************************************************************************/
//> 뼰ʾ
/************************************************************************/

/*
 * ָ(Windowsƽ̨) PLAY_Play֮ǰЧ
 *
 * @param[in] nPort ͨ
 * @param[in] decodeType ģʽH264 Hevc)
 * @param[in] renderType Ⱦģʽ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetEngine(LONG nPort,DecodeType decodeType,RenderType renderType);

/*
 * ͼóɸʱЧãCPUʸߡֶ֧·ʱ
 * ΪԽCPUʡĳ·Ŵ󲥷ʱ·óɸ
 * ԴﵽõĻЧ
 *
 * @param[in] nPort ͨ
 * @param[in] bHighQuality ΪTRUE(1)ʱͼΪFALSE(0)ʱ(Ĭֵ)
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPicQuality(LONG nPort,BOOL bHighQuality);

/*
 * ȡͼ
 *
 * @param[in] nPort ͨ
 * @param[out] bHighQuality TRUEʾFALSEʾ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetPictureQuality(LONG nPort,BOOL *bHighQuality);

/*
 * ֱͬʾء˽ӿPLAY_Play֮ã²ʱá
 * ڲŶ̬ͼֶϲʱʹô˽ӿڴ򿪴ֱͬܡ
 *
 * @param[in] nPort ͨ
 * @param[in] bEnable TRUE򿪴ֱͬFALSEرմֱͬ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_VerticalSyncEnable(LONG nPort, BOOL bEnable);

/*
 * Ƿøͼڲԡ
 *
 * @param[in] nPort ͨ
 * @param[in] bEnable PLAY_STRATEGE_E
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
typedef enum _PLAY_STRATEGE
{
	PLAY_THROW_FRAME_NO = 0,						// ֡
	PLAY_THROW_FRAME_FLAG_HIGHT = 1,				// ĬϲԳ֡1080P4()ϳ֡[1080P,720P]8()ϳ֡С720P16()ϳ֡
	PLAY_THROW_FRAME_FLAG_ALL = 2,					// ǿƳI֡
	PLAY_THROW_FRAME_FLAG_ADAPTION = 3,				// Ӧ֡
	PLAY_THROW_FRAME_FLAG_ADAPTION_LOW_CPU = 4,		// Ӧ֡cpuռ
} PLAY_STRATEGE_E;
PLAYSDK_API BOOL CALLMETHOD PLAY_EnableLargePicAdjustment(LONG nPort, int bEnable);

/*
 * ý߳
 *
 * @param[in] nPort ͨ
 * @param[in] nNum ߳
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecodeThreadNum(LONG nPort, DWORD nNum);

/*
 * ýԣ롣
 *
 * @param[in] nPort ͨ
 * @param[in] nStrategyType 
 *				16: ʾframeǰ
 *               8: ʾݲЭ鵱ɽ
 *				 0 : ʾݲЭ룬Ứ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecodeStrategy(LONG nPort, int nStrategyType);

/*
 * ʹܿأ֧Windows
 *
 * @param[in] nPort ͨ
 * @param[in] bEnable TRUE򿪿ݴFALSEرտݴ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_AntiAliasEnable(LONG nPort, BOOL bEnable);

/************************************************************************/
//> ˽
/************************************************************************/

/*
 * ʾ˽ݣ򣬹򱨾ƶȡ
 *
 * @param[in] nPort ͨ
 * @param[in] bTrue TRUE FALSEر
 * @param[in] nReserve 
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_RenderPrivateData(LONG nPort, BOOL bTrue, LONG nReserve);

/*
 * ֡ص PLAY_SetDataCallBack
 *
 * @param[in] nPort ͨ
 * @param[in] pBuf ͷԭʼ
 * @param[in] nSize  ݴС
 * @param[in] pUserData  ûԶ
 */
typedef void (CALLBACK* fDataCBFun)(LONG nPort,char * pBuf,LONG nSize, void* pUserData);

/*
 * ֡صصͷԭʼݣԼʵֽ
 *
 * @param[in] nPort ͨ
 * @param[out] pDataCBFun ص
 * @param[in] pUserData ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDataCallBack(LONG nPort, fDataCBFun pDataCBFun, void* pUserData);

/*
 * IVSص
 *
 * @param[in] buf ֡(buf json  ֮֡)
 * @param[in] type ֡ 5 json67֮֡
 * @param[in] len ֡ݳ
 * @param[in] reallenlen ֡id
 * @param[in] pReserved 
 * @param[in] pUserData Զ
 */
typedef void (CALLMETHOD *fIVSInfoCallbackFunc)(char* buf, LONG type, LONG len, LONG reallen, void* pReserved, void* pUserData);

/*
 * IVSϢȡ
 *
 * @param[in] nPort ͨ
 * @param[out] pFunc ص
 * @param[in] pUserData Զ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetIVSCallBack(LONG nPort, fIVSInfoCallbackFunc pFunc, void* pUserData);

/*
 * GPSϢص
 *
 * @param[in] pBuf ֡
 * @param[in] nLen ֡ 
 * @param[in] pUserData Զ
 * @return int 
 */
typedef int (CALLBACK *fGPSInfoCallbackFunc)(char* pBuf, LONG nLen, void* pUserData);

/*
 * GPSϢȡ
 *
 * @param[in] nPort ͨ
 * @param[out] pFunc ص  
 * @param[in] pUserData Զ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetGPSCallBack(LONG nPort, fGPSInfoCallbackFunc pFunc, void* pUserData);

/************************************************************************/
//> ƼʹõĽӿ
/************************************************************************/

/*
 * ȡ룬˽ӿЧʹPLAY_GetLastErrorExӿڡ
 *
 * @param[in] nPort,ͨ
 * @return DWORDô롣
 */
PLAYSDK_API DWORD CALLMETHOD PLAY_GetLastError(LONG nPort);

/*
 * ļԶͨš
 *
 * @param[in] sFileName ļ
 * @return DWORDʧܷ0򷵻ͨ
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API DWORD CALLMETHOD PLAY_CreateFile(LPSTR sFileName);

/*
 * رղļͷԶͨš
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_DestroyFile(LONG nPort);

/*
 * ӿڲԶͨš
 *
 * @param[in] nBufPoolSize òдĻСΧ[SOURCE_BUF_MIN,SOURCE_BUF_MAX]
 * @return DWORD,ʧܷ0򷵻ͨ
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API DWORD CALLMETHOD PLAY_CreateStream(DWORD nBufPoolSize);

/*
 * رͷԶͨš
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_DestroyStream(LONG nPort);

/*
 * PLAY_OneByOneBackظʹPLAY_OneByOneBack
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_BackOne(LONG nPort);

/*
 * ÷ֱʸı֪ͨϢ
 *
 * @param[in] nPort ͨ
 * @param[in] hWnd Ϣ͵Ĵ
 * @param[in] nMsg ûϢʱʽıʱûhWndڹյϢ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetEncChangeMsg(LONG nPort,HWND hWnd,UINT nMsg);

/*
 * ļʱҪ͵Ϣ
 *
 * @param[in] nPort ͨ
 * @param[in] hWnd Ϣʹ
 * @param[in] nMsg ûԶϢŵļʱûhWndڹ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetFileEndMsg(LONG nPort,HWND hWnd,UINT nMsg);

#ifdef __cplusplus
}
#endif

#endif
